part of jaguar_generator.models;

abstract class InterceptorMakeParam {
  InterceptorNamedParam makeNamed(String key);
  InterceptorRequiredParam makeReqParam();
}

class InterceptorMakeParamMethod implements InterceptorMakeParam {
  final String methodName;

  final bool isAsync;

  InterceptorMakeParamMethod(this.methodName, this.isAsync);

  InterceptorNamedMakeParamMethod makeNamed(String key) =>
      new InterceptorNamedMakeParamMethod(key, this.methodName, this.isAsync);

  InterceptorRequiredParamMakeParamMethod makeReqParam() =>
      new InterceptorRequiredParamMakeParamMethod(
          this.methodName, this.isAsync);
}

class InterceptorMakeParamSettings implements InterceptorMakeParam {
  final String settingKey;

  final String defaultValue;

  final String filterStr;

  InterceptorMakeParamSettings(
      this.settingKey, this.defaultValue, this.filterStr);

  InterceptorNamedMakeParamSettings makeNamed(String key) =>
      new InterceptorNamedMakeParamSettings(
          key, this.settingKey, this.defaultValue, this.filterStr);

  InterceptorRequiredParamMakeParamSettings makeReqParam() =>
      new InterceptorRequiredParamMakeParamSettings(
          this.settingKey, this.defaultValue, this.filterStr);
}

abstract class InterceptorRequiredParam {}

class InterceptorRequiredParamReprod implements InterceptorRequiredParam {
  final String source;

  InterceptorRequiredParamReprod(this.source);

  bool get shouldMakeFromParam => source == "makeFromParams";
}

class InterceptorRequiredParamMakeParamMethod extends InterceptorMakeParamMethod
    implements InterceptorRequiredParam {
  InterceptorRequiredParamMakeParamMethod(String methodName, bool isAsync)
      : super(methodName, isAsync);
}

class InterceptorRequiredParamMakeParamSettings
    extends InterceptorMakeParamSettings implements InterceptorRequiredParam {
  InterceptorRequiredParamMakeParamSettings(
      String settingKey, String defaultValue, String filterStr)
      : super(settingKey, defaultValue, filterStr);
}

abstract class InterceptorNamedParam {
  String get key;
}

class InterceptorNamedParamReprod implements InterceptorNamedParam {
  final String key;

  final String source;

  InterceptorNamedParamReprod(this.key, this.source);
}

class InterceptorNamedMakeParamMethod extends InterceptorMakeParamMethod
    implements InterceptorNamedParam {
  final String key;

  InterceptorNamedMakeParamMethod(this.key, String methodName, bool isAsync)
      : super(methodName, isAsync);
}

class InterceptorNamedMakeParamSettings extends InterceptorMakeParamSettings
    implements InterceptorNamedParam {
  final String key;

  InterceptorNamedMakeParamSettings(
      this.key, String settingKey, String defaultValue, String filterStr)
      : super(settingKey, defaultValue, filterStr);
}
